<?php

	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
			
	// Check nonce
	if($SHORTCODE_STATUS == false)
    {
		PHPCUS_PARAM::CUS_REQUIRES_NONCE();
	}
	
	// Check Array Input
	PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();
	// Check access rights
	PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_ONLY, 'account_bfip');
	
	if
	(
		PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
		(
			[
					'PARAM_ACC_BFIP_ID',
					'PARAM_ACC_BFIP_IP',
					'PARAM_ACC_BFIP_DESCRIPTION',
					'PARAM_ACC_BFIP_LAST_ACTIVITY_FROM',
					'PARAM_ACC_BFIP_LAST_ACTIVITY_TO',
					'PARAM_ACC_BFIP_FAIL_COUNT_FROM',
					'PARAM_ACC_BFIP_FAIL_COUNT_TO',
					'PARAM_ACC_BFIP_LOCK_COUNT_FROM',
					'PARAM_ACC_BFIP_LOCK_COUNT_TO',
					'PARAM_ACC_BFIP_SUCCESS_COUNT_FROM',
					'PARAM_ACC_BFIP_SUCCESS_COUNT_TO',
					'PARAM_ACC_BFIP_STATUS',
					
					'PARAM_ORDER_FIELD',
					'PARAM_ORDER_TYPE',
					'PARAM_SKIP',
					'PARAM_LIMIT'
			], True
		)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------	
			$PARAM_ACC_BFIP_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ACC_BFIP_ID');
			$PARAM_ACC_BFIP_IP = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_BFIP_IP');
			$PARAM_ACC_BFIP_DESCRIPTION = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_BFIP_DESCRIPTION');
			$PARAM_ACC_BFIP_LAST_ACTIVITY_FROM = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_ACC_BFIP_LAST_ACTIVITY_FROM');
			$PARAM_ACC_BFIP_LAST_ACTIVITY_TO = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_ACC_BFIP_LAST_ACTIVITY_TO');
			$PARAM_ACC_BFIP_FAIL_COUNT_FROM = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ACC_BFIP_FAIL_COUNT_FROM');
			$PARAM_ACC_BFIP_FAIL_COUNT_TO = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ACC_BFIP_FAIL_COUNT_TO');
			$PARAM_ACC_BFIP_LOCK_COUNT_FROM = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ACC_BFIP_LOCK_COUNT_FROM');
			$PARAM_ACC_BFIP_LOCK_COUNT_TO = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ACC_BFIP_LOCK_COUNT_TO');
			$PARAM_ACC_BFIP_SUCCESS_COUNT_FROM = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ACC_BFIP_SUCCESS_COUNT_FROM');
			$PARAM_ACC_BFIP_SUCCESS_COUNT_TO = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ACC_BFIP_SUCCESS_COUNT_TO');
			$PARAM_ACC_BFIP_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_ACC_BFIP_STATUS');
			
			$PARAM_ORDER_FIELD = PHPCUS_PARAM::CUS_READ_SORT_FIELD
			(
					'PARAM_ORDER_FIELD',
					[
						'ACC_BFIP_ID', 
						'ACC_BFIP_IP', 
						'ACC_BFIP_DESCRIPTION', 
						'ACC_BFIP_LAST_ACTIVITY', 
						'ACC_BFIP_FAIL_COUNT', 
						'ACC_BFIP_LOCK_COUNT', 
						'ACC_BFIP_SUCCESS_COUNT', 
						'ACC_BFIP_STATUS'
					]
			);		
			$PARAM_ORDER_TYPE = PHPCUS_PARAM::CUS_READ_SORT_TYPE('PARAM_ORDER_TYPE');
			$PARAM_SKIP	= PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_SKIP');
			$PARAM_LIMIT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_LIMIT');
			
			// ------------------------------------------------------------------
			
			
			// Populate Map Array
			// ...........................................
			$GET_MAP_ARRAY = PHPCUS_ACCOUNT_BFIP::CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			
			$GET_MAP_ARRAY['PARAM_ACC_BFIP_ID'] = $PARAM_ACC_BFIP_ID;
			$GET_MAP_ARRAY['PARAM_ACC_BFIP_IP'] = $PARAM_ACC_BFIP_IP;
			$GET_MAP_ARRAY['PARAM_ACC_BFIP_DESCRIPTION'] = $PARAM_ACC_BFIP_DESCRIPTION;
			$GET_MAP_ARRAY['PARAM_ACC_BFIP_LAST_ACTIVITY_FROM'] = $PARAM_ACC_BFIP_LAST_ACTIVITY_FROM;
			$GET_MAP_ARRAY['PARAM_ACC_BFIP_LAST_ACTIVITY_TO'] = $PARAM_ACC_BFIP_LAST_ACTIVITY_TO;
			$GET_MAP_ARRAY['PARAM_ACC_BFIP_FAIL_COUNT_FROM'] = $PARAM_ACC_BFIP_FAIL_COUNT_FROM;
			$GET_MAP_ARRAY['PARAM_ACC_BFIP_FAIL_COUNT_TO'] = $PARAM_ACC_BFIP_FAIL_COUNT_TO;
			$GET_MAP_ARRAY['PARAM_ACC_BFIP_LOCK_COUNT_FROM'] = $PARAM_ACC_BFIP_LOCK_COUNT_FROM;
			$GET_MAP_ARRAY['PARAM_ACC_BFIP_LOCK_COUNT_TO'] = $PARAM_ACC_BFIP_LOCK_COUNT_TO;
			$GET_MAP_ARRAY['PARAM_ACC_BFIP_SUCCESS_COUNT_FROM'] = $PARAM_ACC_BFIP_SUCCESS_COUNT_FROM;
			$GET_MAP_ARRAY['PARAM_ACC_BFIP_SUCCESS_COUNT_TO'] = $PARAM_ACC_BFIP_SUCCESS_COUNT_TO;
			$GET_MAP_ARRAY['PARAM_ACC_BFIP_STATUS'] = $PARAM_ACC_BFIP_STATUS;
			
			$GET_MAP_ARRAY["PARAM_ORDER_FIELD"] = $PARAM_ORDER_FIELD;
			$GET_MAP_ARRAY["PARAM_ORDER_TYPE"] = $PARAM_ORDER_TYPE;
			$GET_MAP_ARRAY["PARAM_SKIP"] = $PARAM_SKIP;
			$GET_MAP_ARRAY["PARAM_LIMIT"] = $PARAM_LIMIT;
			
			
			// Execute Stored Procedure
			// ...........................................
			$DATA_SET = PHPCUS_ACCOUNT_BFIP::CUS_GET_MA($GET_MAP_ARRAY);
			
						
			// Return JSON response
			// ...........................................
			PHPCUS_SHORTCODE::CUS_QUICK_LOGOUT();
			if(empty($DATA_SET) === False)
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
			}
			else
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS('');
			}
			
		}
		Catch(Exception $ERR)
		{
			PHPCUS_SHORTCODE::CUS_QUICK_LOGOUT();
			
			PHPVC_LOG::VAR_REPORT_ERROR($ERR, 0);
			if(isset($_SERVER['HTTP_ORIGIN']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_ORIGIN', $_SERVER['HTTP_ORIGIN']);
			}
			if(isset($_SERVER['HTTP_HOST']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_HOST', $_SERVER['HTTP_HOST']);
			}		
			if(isset($_SERVER['HTTP_REFERER']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_REFERER', $_SERVER['HTTP_REFERER']);
			}
			if(isset($_SERVER['REMOTE_ADDR']))
			{
			    PHPVC_LOG::VAR_ERROR('REMOTE_ADDR', $_SERVER['REMOTE_ADDR']);
			}
			
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR->getMessage());
		}
	}
	else
	{
		PHPCUS_SHORTCODE::CUS_QUICK_LOGOUT();
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>